.386

.MODEL FLAT,STDCALL

OPTION CASEMAP:NONE

WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\user32.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\kernel32.lib

.DATA

ClassName  DB "DLGCLASS",0
MenuName   DB "MyMenu",0
DlgName    DB "MyDialog",0
AppName    DB "Nasze pierwsze okno dialogowe",0
TestString DB "Och! Jestem w edytorze",0

.DATA?

hInstance   HINSTANCE ?
CommandLine LPSTR     ?
buffer      db 512 dup(?)

.CONST

IDC_EDIT    EQU  3000
IDC_BUTTON  EQU  3001
IDC_EXIT    EQU  3002
IDM_GETTEXT EQU 32000
IDM_CLEAR   EQU 32001
IDM_EXIT    EQU 32002

.CODE

start:
    INVOKE GetModuleHandle, NULL
    mov    hInstance, eax
    INVOKE GetCommandLine
    mov    CommandLine, eax
    INVOKE WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
    INVOKE ExitProcess, eax
	
WinMain PROC hInst:     HINSTANCE,\
             hPrevInst: HINSTANCE,\
             CmdLine:   LPSTR,\
             CmdShow:   DWORD

LOCAL wc:   WNDCLASSEX
LOCAL msg:  MSG
LOCAL hDlg: HWND

    mov    wc.cbSize, SIZEOF WNDCLASSEX
    mov    wc.style, CS_HREDRAW OR CS_VREDRAW
    mov    wc.lpfnWndProc, OFFSET WndProc
    mov    wc.cbClsExtra, NULL
    mov    wc.cbWndExtra, DLGWINDOWEXTRA
    push   hInst
    pop    wc.hInstance
    mov    wc.hbrBackground, COLOR_BTNFACE+1
    mov    wc.lpszMenuName, OFFSET MenuName
    mov    wc.lpszClassName, OFFSET ClassName
    INVOKE LoadIcon, NULL, IDI_APPLICATION
    mov    wc.hIcon, eax
    mov    wc.hIconSm, eax
    INVOKE LoadCursor, NULL, IDC_ARROW
    mov    wc.hCursor, eax
    INVOKE RegisterClassEx, ADDR wc
    INVOKE CreateDialogParam, hInstance, ADDR DlgName, NULL, NULL, NULL
    mov    hDlg, eax
    INVOKE GetDlgItem, hDlg, IDC_EDIT
    INVOKE SetFocus, eax	
    INVOKE ShowWindow, hDlg, SW_SHOWNORMAL
    INVOKE UpdateWindow, hDlg

    .WHILE TRUE
        INVOKE GetMessage, ADDR msg, NULL, 0, 0
        .BREAK .IF (!eax)
        INVOKE IsDialogMessage, hDlg, ADDR msg
        .IF eax==FALSE
            INVOKE TranslateMessage, ADDR msg
            INVOKE DispatchMessage, ADDR msg
        .ENDIF
    .ENDW

    mov     eax, msg.wParam
    ret
WinMain ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    .IF uMsg==WM_CREATE
        INVOKE SetDlgItemText, hWnd, IDC_EDIT, ADDR AppName
    .ELSEIF uMsg==WM_DESTROY
        INVOKE PostQuitMessage, NULL
    .ELSEIF uMsg==WM_COMMAND
        mov eax, wParam
        .IF lParam==0
            .IF ax==IDM_GETTEXT
                INVOKE GetDlgItemText, hWnd, IDC_EDIT, ADDR buffer, 512
                INVOKE MessageBox, NULL, ADDR buffer, ADDR AppName, MB_OK
            .ELSEIF ax==IDM_CLEAR
                INVOKE SetDlgItemText, hWnd, IDC_EDIT, NULL
            .ELSE
                INVOKE DestroyWindow, hWnd
            .ENDIF
        .ELSE
            mov dx, WORD PTR wParam + 2
            .IF dx==BN_CLICKED
                .IF ax==IDC_BUTTON
                    INVOKE SetDlgItemText, hWnd, IDC_EDIT, ADDR TestString
                .ELSEIF ax==IDC_EXIT
                    INVOKE SendMessage, hWnd, WM_COMMAND, IDM_EXIT, 0
                .ENDIF
            .ENDIF
        .ENDIF
    .ELSE
        INVOKE DefWindowProc, hWnd, uMsg, wParam, lParam
        ret
    .ENDIF

    xor eax, eax
    ret
    
WndProc ENDP

END start
